require 'spec_helper'

RSpec.describe KarrierWave::RemoteFile do
  describe '#generate_tempfile_from' do
    let(:stub_tempfile) { double(write: nil, close: nil, binmode: nil, :"<<" => nil) }
    let(:file) { double() }
    let(:remote_file) { KarrierWave::RemoteFile.new(file) }
    let(:string_io) { StringIO.new('abcd') }

    before { allow(string_io).to receive(:base_uri) { URI.parse('http://google.com/logo.png') } }
    before { allow(string_io).to receive(:meta) { 'meta' } }
    before { allow(string_io).to receive(:metas) { {} } }
    before { allow(string_io).to receive(:status) { 200 } }
    before { allow(Tempfile).to receive(:new) { stub_tempfile } }

    it { expect(remote_file.send(:generate_tempfile_from, string_io)).to be_respond_to(:base_uri) }
    it { expect(remote_file.send(:generate_tempfile_from, string_io)).to be_respond_to(:meta) }
  end
end
